//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include <Clipbrd.hpp>

#include "DragonUnit.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)
#pragma resource "*.dfm"

//---------------------------------------------------------------------------

TForm1* Form1;

//---------------------------------------------------------------------------

bool CALLBACK EnumWindowsProc(HWND, LPARAM);

//---------------------------------------------------------------------------

__fastcall TForm1::TForm1(TComponent* Owner)
  : TForm(Owner)
{

  UpdateListBox();

}

//---------------------------------------------------------------------------

__fastcall TForm1::~TForm1()
{

  MessageBox
  (
    0,
    "Never hope to grasp the source of our power",
    "JTHZ",
    MB_ABORTRETRYIGNORE	| MB_ICONQUESTION
  );

}

//---------------------------------------------------------------------------

void __fastcall TForm1::UpdateButtonClick(TObject *Sender)
{

  UpdateListBox();

}

//---------------------------------------------------------------------------

bool CALLBACK EnumWindowsProc
  (
    HWND   Window,
    LPARAM Parameter
  )
{

  char Buffer[256];

  if(GetWindowText(Window, Buffer, sizeof(Buffer)))
  {
    TListBox* ListBox = reinterpret_cast <TListBox*> (Parameter);
    ListBox->Items->Add(Buffer);
  }

  return true;

}

//---------------------------------------------------------------------------

void __fastcall TForm1::ListBox1Click(TObject *Sender)
{

  KillButton->Enabled = (ListBox1->ItemIndex >= 0);

}

//---------------------------------------------------------------------------

void __fastcall TForm1::KillButtonClick(TObject *Sender)
{

  int Idx = ListBox1->ItemIndex;
  if(Idx < 0)
  {
    return;
  }

  AnsiString CaptionText = ListBox1->Items->Strings[Idx];

  Clipboard()->AsText = CaptionText;

  HWND Window = FindWindow(0, CaptionText.c_str());

  if(IsWindow(Window))
  {
    PostMessage
    (
      Window,
      WM_QUERYENDSESSION,
      0,
      ENDSESSION_LOGOFF
    );

    PostMessage
    (
      Window,
      WM_ENDSESSION,
      1,
      ENDSESSION_LOGOFF
    );

    PostMessage
    (
      Window,
      WM_QUIT,
      0,
      0
    );

    Sleep(250);

    UpdateListBox();

  }
  else
  {
    MessageDlg
    (
      "FindWindow() failed",
      mtInformation,
      TMsgDlgButtons() << mbAbort,
      0
    );
  }

}

//---------------------------------------------------------------------------

void TForm1::UpdateListBox()
{

  KillButton->Enabled = false;

  ListBox1->Clear();

  EnumWindows
  (
    reinterpret_cast <WNDENUMPROC> (EnumWindowsProc),
    reinterpret_cast <LPARAM> (ListBox1)
  );

}

//---------------------------------------------------------------------------


